#!/bin/sh

SED=sed
TAR=tar

case "`(uname -sr)2>/dev/null`" in
     "Linux"*)
	DEFAULT_INSTALL_DIR="/opt/drweb"
	INSTALL_PKG="./drweb-4.25-linux.tar.gz"
	;;
     "FreeBSD 4"*)
        DEFAULT_INSTALL_DIR="/usr/local/drweb"
 	INSTALL_PKG="./drweb-4.25-freebsd4.tar.gz"
        ;;
     "FreeBSD 3"*)
        DEFAULT_INSTALL_DIR="/usr/local/drweb"
 	INSTALL_PKG="./drweb-4.25-freebsd3.tar.gz"
        ;;
     *)
        echo
        echo "Unknown platfrom!"
        echo
        exit 1
        ;;
esac

if [ ! -f $INSTALL_PKG ] ; then
   echo
   echo "Can not find $INSTALL_PKG!"
   echo
   exit 1
fi

INSTALL_DIR=""
while [ "$INSTALL_DIR" = "" ]
do
	echo "Enter destination directory ($DEFAULT_INSTALL_DIR is default):"
	read INPUT
	if [ "$INPUT" = "" ] ; then
	   INPUT=$DEFAULT_INSTALL_DIR
	fi
	if [ -d "$INPUT" ] ; then
	   echo "Directory $INPUT already exists!"
	else
     	   mkdir $INPUT
   	   if [ ! -d "$INPUT" ] ; then
	      echo "Can not create $INPUT!"
   	   else
	      INSTALL_DIR=$INPUT
	   fi
	fi
done

$TAR -xzf $INSTALL_PKG -C $INSTALL_DIR

if [ ! -f $INSTALL_DIR/drweb32.ini ] ; then
   echo
   echo "Failed!"
   echo
   exit 1
fi

LNG=""
while [ "$LNG" = "" ]
do
   echo "Select interface language: 0) english  1) russian"
   read INPUT
   case $INPUT in
    0)
      LNG="english"
      ;;
    1)
      LNG="russian"
      ;;
    *)
      echo "Wrong choice!"
      ;;
   esac
done

$SED -e "s&__INSTALL_DIR__&$INSTALL_DIR&" $INSTALL_DIR/drweb32.ini > $INSTALL_DIR/drweb32.ini.tmp
mv $INSTALL_DIR/drweb32.ini.tmp $INSTALL_DIR/drweb32.ini
if [ ! "$LNG" = "english" ] ; then
   $SED -e "s&;LngFileName&LngFileName&" $INSTALL_DIR/drweb32.ini > $INSTALL_DIR/drweb32.ini.tmp
   mv $INSTALL_DIR/drweb32.ini.tmp $INSTALL_DIR/drweb32.ini
fi

if [ ! "$INSTALL_DIR" = "$DEFAULT_INSTALL_DIR" ] ; then
     echo "#! /bin/sh" > $INSTALL_DIR/drweb.sh
     echo "$INSTALL_DIR/drweb -ini:$INSTALL_DIR/drweb32.ini \$1 \$2 \$3 \$4 \$5 \$6 \$7 \$8 \$9" >> $INSTALL_DIR/drweb.sh
     chmod 755 $INSTALL_DIR/drweb.sh
fi     

echo
echo "Dr.Web is installed to $INSTALL_DIR." 
echo "Edit $INSTALL_DIR/drweb32.ini to complete setup." 
if [ ! "$INSTALL_DIR" = "$DEFAULT_INSTALL_DIR" ] ; then
   echo "Execute $INSTALL_DIR/drweb.sh to run Dr. Web scanner." 
fi
echo

exit 0
