#! /usr/bin/perl -w
#
# Update DrWEB virus base
# ./update.pl data_directory [command_url]
#
# Commands:
# '-' remove file
# '+' check crc and update file
# '=' force update file
# ''  force update file
#
# Security: filename pattern is '\w[\w\.]*' (only current directory).
#
use strict;
use String::CRC32;

my $version = '425';
my $url = $ARGV[1] || 'http://www.drweb.ru/ftp/update_free/linux/drweb32.lst';
#my $url = $ARGV[1] || 'http://www.drweb.ru/ftp/update_free/freebsd3/drweb32.lst';
#my $url = $ARGV[1] || 'http://www.drweb.ru/ftp/update_free/freebsd4/drweb32.lst';

my $fetch = ''; # autotest for fetch, wget
unless ( $fetch ) { $fetch.=" -q -o" if chomp ( $fetch = `which fetch` ); }
unless ( $fetch ) { $fetch.=" -q -O" if chomp ( $fetch = `which wget` ); }
die "Cat't found fetch or wget" unless $fetch;

chdir $ARGV[0] or die "Can't chdir to $ARGV[0] $!"
    if defined $ARGV[0];    # change current directory

die "Incorrect url $url" if $url !~ m/^(.*)\/([\w.]+)$/o;
my ( $b_url, $l_url ) = ( $1, $2 );

# read update list to %chg, %add, %del
my %del; my %add;
open FH, "$fetch - $b_url/$l_url |" or die "Can't $fetch - $b_url/$l_url";
my $my_section = 0; # each version have own list section
while ( <FH> ) {
    tr/\012\015//d; # remove all newlines
    $my_section = ($1 eq $version), next if /^\[(.+)\]/o; # new section ?
    next unless $my_section;    # later only our section
    $del{$1} = hex($2) || '', next
        if /^\-(\w[\w\.]*)[, \t]*([a-fA-F\d]*)/o;
    $del{$1} = $add{$1} = hex($2) || '', next
        if /^\=(\w[\w\.]*)[, \t]*([a-fA-F\d]*)/o;
    $add{$1} = hex($2) || '', next
        if /^\+?(\w[\w\.]*)[, \t]*([a-fA-F\d]*)/o;
}
close FH;

# delete all exist old files, CRC ignored
foreach my $file ( sort keys %del ) {
    next unless -e $file;
    unlink $file or warn "Can't delete old file $file $!";
}

# calculate crc32 checksum (or return '')
sub file_crc {
    open FH, $_[0] or return '';
    my $crc32 = crc32(*FH); close FH; return $crc32;
}

# add new files, CRC tested
foreach my $file ( sort keys %add ) {
    if ( -e $file ) { # next if file crc = list crc
        next if $add{$file} ne '' and $add{$file} == &file_crc($file);
        unlink $file or die "Can't remove $file $!";
    }
    # download new file
    `$fetch $file $b_url/$file`;
    warn "Can't $fetch $file" unless -e $file;
    # test crc32 of new file
    next if $add{$file} ne '' and $add{$file} == &file_crc($file);
    warn "Can't $fetch $file with correct CRC32";
    unlink $file;   # incorrect CRC, remove file!
}

